
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Apache Storm技术实战 / iVAN</title>

    <meta name="description" content="Apache Storm技术实战  WordCountTopology &quot;源码走读系列&quot;从代码层面分析了storm的具体实现,接下来通过具体的实例来说明storm的使用.因为目前storm已经正式迁移到Apache,文章系列也由twitter storm转为apache storm. WordCountTopology 使用storm来统计文件中的每个单词的出现次数. 通过该例子来说明tuple发送时的几个要素 source component   发送源 destination component 接收者  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Apache Storm技术实战</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1><a href="http://www.cnblogs.com/hseagle/p/3505938.html" rel="external nofollow noreferrer"> WordCountTopology</a></h1>
<p>“源码走读系列”从代码层面分析了storm的具体实现，接下来通过具体的实例来说明storm的使用。因为目前storm已经正式迁移到Apache，文章系列也由twitter storm转为apache storm.</p>
<p>WordCountTopology 使用storm来统计文件中的每个单词的出现次数。</p>
<p>通过该例子来说明tuple发送时的几个要素</p>
<ol>
<li>source component   发送源</li>
<li>destination component 接收者</li>
<li>stream 消息通道</li>
<li>tuple    消息本身</li>
</ol>
<p>本文涉及到的开发环境搭建可以参考前面的两篇博文。</p>
<ol>
<li><a href="http://www.cnblogs.com/hseagle/p/3299713.html" rel="external nofollow noreferrer">arch linux简明安装指南</a></li>
<li><a href="http://www.cnblogs.com/hseagle/p/3373701.html" rel="external nofollow noreferrer">在archlinux上搭建storm cluster</a></li>
</ol>
<h1>awk实现</h1>
<p>其实对文件中的单词进行统计是Linux下一个很常见的任务，用awk就可以轻松的解决(如果文件不是太大的话),下面是进行word counting的awk脚本，将其保存为名为wordcount.awk文件。</p>
<p>wordcount.awk</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>{
  for (i = 1; i&lt;=NF; i++)
    freq[$i]++
}
END{
  for (word in freq)
    printf "%s\t%d\n",word,freq[word]
}</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>运行该脚本，对文件中的单词进行统计</p>
<pre>gawk -f wordcount.awk filename</pre>

<h1>原始版本<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ2OTc3NS8yMDE0MDEvMDUyMDIyMzUtZjZkMjZkY2Y0ZGNlNDMxOWI5NmExOWRhZGUyYzg1ZTYucG5n.jpg"></h1>
<p>从github上复制内容</p>
<pre>git clone https://github.com/nathanmarz/storm-starter.git</pre>
<p>编译运行</p>
<pre>lein deps
lein compile
java -cp $(lein classpath) WordCountTopology</pre>

<h2>main函数</h2>
<p>main函数的主要内容</p>
<pre>    TopologyBuilder builder = new TopologyBuilder();
    builder.setSpout("spout", new RandomSentenceSpout(), 5);
    builder.setBolt("split", new SplitSentence(), 8).shuffleGrouping("spout");
    builder.setBolt("count", new WordCount(), 12).fieldsGrouping("split", new Fields("word"));</pre>
<p><strong>注意：grouping操作的时候，如果没有显示指定stream id，则使用的是default stream. 如shuffleGrouping("spout")表示从名为spout的component中接收从default stream发送过来的tuple.</strong></p>
<h1>改进版本</h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ2OTc3NS8yMDE0MDEvMDUyMDIyNDgtNjNmMjJkZjQ0NDBjNDNjOGExYmQzYzRjYTNkZTdlNGYucG5n.jpg"></p>
<p>在原始版本中，spout不停的向split bolt随机发送句子，Count bolt统计每个单词出现的次数。</p>
<p>那么能不能让Spout在读取完文件之后，通知下游的bolt显示最柊的统计结果呢？</p>
<p>要想达到上述的改进目标，采用如上图所示的结构即可。改变的地方如下，</p>
<ol>
<li>在Spout中添加一个SUCCESS_STREAM</li>
<li>添加只有一个运行实例的statistics bolt</li>
<li>当spout读取完文件内容之后，通过SUCCESS_STREAM告诉statistics bolt，文件已经处理完毕，可以打印当前的统计结果</li>
</ol>
<h2>RandomSentenceSpout.java</h2>
<h3>declareOutputFields</h3>
<p>添加SUCCESS_STREAM</p>
<pre>@Override
  public void declareOutputFields(OutputFieldsDeclarer declarer) {
    declarer.declare(new Fields("word"));
    declarer.declareStream("SUCCESS_STREAM",new Fields("word"));
  }</pre>

<h3>nextTuple</h3>
<p>使用SUCCESS_STREAM通知下游，文件处理完毕</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>@Override
  public void nextTuple() {
    Utils.sleep(100);
    String[] sentences = new String[]{ "the cow jumped over the moon", "an apple a day keeps the doctor away",
        "four score and seven years ago", "snow white and the seven dwarfs", "i am at two with nature" };
    if ( count == sentences.length )
    {
      System.out.println(count+" try to emit tuple by success_stream");
      _collector.emit("SUCCESS_STREAM",new Values(sentences[0]));
      count++;
    }else if ( count &lt; sentences.length ){
      _collector.emit(new Values(sentences[count]));
      count++;
    }
  }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<h2>WordCountTopology.java</h2>
<h3>添加静态类WordCount2</h3>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>public static class WordCount2 extends BaseBasicBolt {
    Map&lt;String, Integer&gt; counts = new HashMap&lt;String, Integer&gt;();

    @Override
    public void execute(Tuple tuple, BasicOutputCollector collector) {
      if ( tuple.getSourceStreamId() == "SUCCESS_STREAM" ) {
    System.out.println("prepare to print the statistics");
    for (String key : counts.keySet()) {
      System.out.println(key+"\t"+counts.get(key));
    }
    System.out.println("finish printing");
      }else {

    String word = tuple.getString(0);
    Integer count = counts.get(word);
    if (count == null)
      count = 0;
    count++;
    counts.put(word, count);
      }
    }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p> </p>
<h3>main函数</h3>
<p>将spout的并行数由5改为1</p>
<pre> builder.setSpout("spout", new RandomSentenceSpout(), 1);</pre>
<p>在原有的Topology中添加WordCount2 Bolt</p>
<pre> builder.setBolt("count2", new WordCount2(), 1).globalGrouping("count").globalGrouping("spout","SUCCESS_STREAM");</pre>
<p>WordCount2 Bolt会接收从Count Bolt通过default stream发送的tuple，同时接收Spout通过SUCCESS_STREAM发送的tuple，也就是说wordcount2会接收从两个stream来的数据。</p>
<h2>编译</h2>
<p>编译修改后的源文件</p>
<pre>cd $STROM_STARTER
lein compile storm.starter </pre>
<p>可能会出现以下异常信息，该异常可以忽略。</p>
<pre>Exception in thread "main" java.io.FileNotFoundException: Could not locate storm/starter/WordCountTopology__init.class or storm/starter/WordCountTopology.clj on classpath:</pre>

<h2>运行</h2>
<p>在local模式下运行修改后的WordCountTopology</p>
<pre>java -cp $(lein classpath) storm.starter.WordCountTopology</pre>
<p>如果一切正常，日志如下所示，线程的名字可能会有所不同。</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>moon    1
score    1
cow    1
doctor    1
over    1
nature    1
snow    1
four    1
keeps    1
with    1
a    1
white    1
dwarfs    1
at    1
the    4
and    2
i    1
two    1
away    1
seven    2
apple    1
am    1
an    1
jumped    1
day    1
years    1
ago    1</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<h1> 结果验证</h1>
<p>可以将WordCountTopology的运行结果和awk脚本的运行结果相比对，结果应该是一致的。</p>
<h2>小技巧</h2>
<ol>
<li>awk脚本的执行结果存为一个文件result1.log, WordCountTopology的输出中单词统计部分存为result2.log</li>
<li>用vim打开result1.log，进行sorting，保存结果;用vim打开result2.log，进行sorting，保存。</li>
<li>然后用vimdiff来进行比较 vimdiff result1.log result2.log</li>
</ol>
<h1><a href="http://www.cnblogs.com/hseagle/p/3511185.html" rel="external nofollow noreferrer">BasicDRPCTopology</a></h1>
<p>本文通过BasicDRPCTopology的实例来分析DRPCTopology在提交的时候, Topology中究竟含有哪些内容?</p>
<h1>BasicDRPCTopology</h1>
<h2>main函数</h2>
<p>DRPC 分布式远程调用(这个说法有意思,远程调用本来就是分布的,何须再加个D, &lt;头文字D&gt;看多了, :)</p>
<p> </p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>public static void main(String[] args) throws Exception {
    LinearDRPCTopologyBuilder builder = new LinearDRPCTopologyBuilder("exclamation");
    builder.addBolt(new ExclaimBolt(), 3);

    Config conf = new Config();

    if (args == null || args.length == 0) {
      LocalDRPC drpc = new LocalDRPC();
      LocalCluster cluster = new LocalCluster();

      cluster.submitTopology("drpc-demo", conf, builder.createLocalTopology(drpc));

      for (String word : new String[]{ "hello", "goodbye" }) {
        System.out.println("Result for \"" + word + "\": " + drpc.execute("exclamation", word));
      }

      cluster.shutdown();
      drpc.shutdown();
    }
    else {
      conf.setNumWorkers(3);
      StormSubmitter.submitTopology(args[0], conf, builder.createRemoteTopology());
    }
  }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p> </p>
<p>问题: 上面的代码中只是添加了一个bolt,并没有设定Spout. 我们知道一个topology中最起码得有一个Spout,那么这里的Spout又隐身于何处呢?</p>
<p>关键的地方就在<strong>builder.createLocalTopology,</strong> 调用关系如下</p>
<ul>
<li>LinearDRPCTopologyBuilder::createLocalTopology</p>
<ul>
<li>　　LinearDRPCTopologyBuilder::createTopology()</p>
<ul>
<li>　　LinearDRPCTopologyBuilder::createTopology(new DRPCSpout(_function))</li>
</ul>
<p> </li>
</ul>
</li>
</ul>
<p>原来DRPCTopology中使用的Spout是DRPCSpout.</p>
<h2>LinearDRPCTopology::createTopology</h2>
<p>既然代码已经读到此处,何不再进一步看看createTopology的实现.</p>
<p>简要说明一下该段代码的处理逻辑:</p>
<ol>
<li>设置DRPCSpout</li>
<li>以bolt为入参,创建CoordinatedBolt</li>
<li>添加JoinResult Bolt</li>
<li>添加ReturnResult Bolt: ReturnResultBolt连接到DRPCServer,并返回结果</li>
</ol>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>    private StormTopology createTopology(DRPCSpout spout) {
        final String SPOUT_ID = "spout";
        final String PREPARE_ID = "prepare-request";

        TopologyBuilder builder = new TopologyBuilder();
        builder.setSpout(SPOUT_ID, spout);
        builder.setBolt(PREPARE_ID, new PrepareRequest())
                .noneGrouping(SPOUT_ID);
        int i=0;
        for(; i&lt;_components.size();i++) {
            Component component = _components.get(i);

            Map&lt;String, SourceArgs&gt; source = new HashMap&lt;String, SourceArgs&gt;();
            if (i==1) {
                source.put(boltId(i-1), SourceArgs.single());
            } else if (i&gt;=2) {
                source.put(boltId(i-1), SourceArgs.all());
            }
            IdStreamSpec idSpec = null;
            if(i==_components.size()-1 &amp;&amp; component.bolt instanceof FinishedCallback) {
                idSpec = IdStreamSpec.makeDetectSpec(PREPARE_ID, PrepareRequest.ID_STREAM);
            }
            BoltDeclarer declarer = builder.setBolt(
                    boltId(i),
                    new CoordinatedBolt(component.bolt, source, idSpec),
                    component.parallelism);

            for(Map conf: component.componentConfs) {
                declarer.addConfigurations(conf);
            }

            if(idSpec!=null) {
                declarer.fieldsGrouping(idSpec.getGlobalStreamId().get_componentId(), PrepareRequest.ID_STREAM, new Fields("request"));
            }
            if(i==0 &amp;&amp; component.declarations.isEmpty()) {
                declarer.noneGrouping(PREPARE_ID, PrepareRequest.ARGS_STREAM);
            } else {
                String prevId;
                if(i==0) {
                    prevId = PREPARE_ID;
                } else {
                    prevId = boltId(i-1);
                }
                for(InputDeclaration declaration: component.declarations) {
                    declaration.declare(prevId, declarer);
                }
            }
            if(i&gt;0) {
                declarer.directGrouping(boltId(i-1), Constants.COORDINATED_STREAM_ID);
            }
        }

        IRichBolt lastBolt = _components.get(_components.size()-1).bolt;
        OutputFieldsGetter getter = new OutputFieldsGetter();
        lastBolt.declareOutputFields(getter);
        Map&lt;String, StreamInfo&gt; streams = getter.getFieldsDeclaration();
        if(streams.size()!=1) {
            throw new RuntimeException("Must declare exactly one stream from last bolt in LinearDRPCTopology");
        }
        String outputStream = streams.keySet().iterator().next();
        List&lt;String&gt; fields = streams.get(outputStream).get_output_fields();
        if(fields.size()!=2) {
            throw new RuntimeException("Output stream of last component in LinearDRPCTopology must contain exactly two fields. The first should be the request id, and the second should be the result.");
        }

        builder.setBolt(boltId(i), new JoinResult(PREPARE_ID))
                .fieldsGrouping(boltId(i-1), outputStream, new Fields(fields.get(0)))
                .fieldsGrouping(PREPARE_ID, PrepareRequest.RETURN_STREAM, new Fields("request"));
        i++;
        builder.setBolt(boltId(i), new ReturnResults())
                .noneGrouping(boltId(i-1));
        return builder.createTopology();
    }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p> </p>
<h2>Bolt</h2>
<p>处理逻辑: 在接收到的每一个单词后面添加'!'.</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre> public static class ExclaimBolt extends BaseBasicBolt {
    @Override
    public void execute(Tuple tuple, BasicOutputCollector collector) {
      String input = tuple.getString(1);
      collector.emit(new Values(tuple.getValue(0), input + "!"));
    }

    @Override
    public void declareOutputFields(OutputFieldsDeclarer declarer) {
      declarer.declare(new Fields("id", "result"));
    }
  }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<h1>运行</h1>
<p><pre>java -cp $(lein classpath) storm.starter.BasicDRPCTopology</pre>

<h1><a href="http://www.cnblogs.com/hseagle/p/3516458.html" rel="external nofollow noreferrer"> </a><a href="http://www.cnblogs.com/hseagle/p/3516458.html" rel="external nofollow noreferrer">TridentWordCount</a></h1>
<p>介绍TridentTopology的使用，重点分析newDRPCStream和stateQuery的实现机理。 </p>
<p>使用TridentTopology进行数据处理的时候，经常会使用State来保存一些状态，这些保存起来的State通过stateQuery来进行查询。问题恰恰在这里产生，即对state进行更新的Stream和尔后进行stateQuery的Stream并非同一个，那么它们之间是如何关联起来的呢。</p>
<p>在TridentTopology中，有一些Processor可能会同处于一个Bolt中，这些Processor形成一个processing chain, 那么Tuple又是如何在这些Processor之间进行传递的呢。</p>
<h1>TridentWordCount</h1>
<h2>编译和运行</h2>
<p><pre>lein compile storm.starter.trident.TridentWordCount
java -cp $(lein classpath) storm.starter.trident.TridentWordCount </pre>

<h2>main函数</h2>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>public static void main(String[] args) throws Exception {
    Config conf = new Config();
    conf.setMaxSpoutPending(20);
    if (args.length == 0) {
      LocalDRPC drpc = new LocalDRPC();
      LocalCluster cluster = new LocalCluster();
      cluster.submitTopology("wordCounter", conf, buildTopology(drpc));
      for (int i = 0; i &lt; 100; i++) {
        System.out.println("DRPC RESULT: " + drpc.execute("words", "cat the dog jumped"));
        Thread.sleep(1000);
      }
    }
    else {
      conf.setNumWorkers(3);
      StormSubmitter.submitTopology(args[0], conf, buildTopology(null));
    }
  } </pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<h2>buildTopology</h2>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre> public static StormTopology buildTopology(LocalDRPC drpc) {
    FixedBatchSpout spout = new FixedBatchSpout(new Fields("sentence"), 3, new Values("the cow jumped over the moon"),
        new Values("the man went to the store and bought some candy"), new Values("four score and seven years ago"),
        new Values("how many apples can you eat"), new Values("to be or not to be the person"));
    spout.setCycle(true);

    TridentTopology topology = new TridentTopology();
    TridentState wordCounts = topology.newStream("spout1", spout).parallelismHint(16).each(new Fields("sentence"),
        new Split(), new Fields("word")).groupBy(new Fields("word")).persistentAggregate(new MemoryMapState.Factory(),
        new Count(), new Fields("count")).parallelismHint(16);

    topology.newDRPCStream("words", drpc).each(new Fields("args"), new Split(), new Fields("word")).groupBy(new Fields(
        "word")).stateQuery(wordCounts, new Fields("word"), new MapGet(), new Fields("count")).each(new Fields("count"),
        new FilterNull()).aggregate(new Fields("count"), new Sum(), new Fields("sum"));
    return topology.build();
  } </pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<h1>示意图</h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ2OTc3NS8yMDE0MDEvMjUyMDQyMDgwMzIzMzEwLnBuZw==.jpg"></p>
<p> </p>
<p>在整个topology中，有两个不同的spout。</p>
<h1>运行结果该如何理解</h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ2OTc3NS8yMDE0MDEvMjMwOTM5MTgyNTc0LnBuZw==.jpg"></p>
<p>此图有好几个问题</p>
<ol>
<li>PartitionPersistProcessor和StateQueryProcessor同处于一个bolt,该bolt为SubtopologyBolt</li>
<li>SubtopologyBolt有来自多个不同Stream的输入，根据不同的Streamid找到对应的InitialReceiver</li>
<li>drpcspout在执行的时候,是一直不停的emit消息到SubtopologyBolt,还是发送完一次消息就停止发送</li>
</ol>
<p>不同的tuple,其sourcestream不一样,根据SourceStream,找到对应的InitialReceiver</p>
<pre>    Map&lt;String, InitialReceiver&gt; _roots = new HashMap(); </pre>
<p> </p>
<h1>状态更新</h1>
<p>进行状态更新的Processor名为PartitionPersistProcessor</p>
<h2>execute</h2>
<p>记录哪些tuple需要进行状态更新</p>
<h2>finishBatch</h2>
<p>状态真正更新是发生在finishBatch阶段</p>
<p>persistentAggregate</p>
<p>PartitionPersistProcessor</p>
<ul>
<li>SubtopologyBolt::execute</p>
<ul>
<li>PartitionPersistProcessor::finishBatch</p>
<ul>
<li>　　_updater::updateState</p>
<ul>
<li>Snapshottable::update</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p>当状态更新的时候，状态查询是否会发生？</p>
<h1>状态查询</h1>
<p>进行状态查询的Processor名为StateQueryProcessor</p>
<h2>execute</h2>
<h2>finishBatch</h2>
<p>查询的时候，首先调用batchRetrieive来获得最新的状态更新结果，再对每个最新的结果使用_function来进行处理。</p>
<p>调用层次</p>
<ul>
<li>SubtopologyBolt::finishBatch</p>
<ul>
<li>　　StateQueryProcessor::finishBatch</p>
<ul>
<li>_function.batchRetrieve</li>
<li>_function.execute   将处理过的结果发送给下一跳进行处理<br />
<br /> </li>
</ul>
</li>
</ul>
</li>
</ul>
<h1>消息的传递</h1>
<h2>TridentTuple</h2>
<p>如何决定bolt内部的哪个processor来处理接收到的消息,这个是根据不同的Stream来判断InitialReceiver完成。</p>
<p>当SubtopologyBolt接收到最原始的tuple时，根据streamid找到InitialReceiver后，InitialReceiver在<strong>receive</strong>函数中作的第一件事情就是根据tuple来创建一个tridenttuple，tridenttuple会被处在同一个SubtopologyBolt中的processor一一处理，处理的结果是保存在tridenttuple和processorcontext中。</p>
<h2>ProcessorContext</h2>
<p>ProcessorContext记录两个重要的信息，即当前的batchId和batchState.</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>public class ProcessorContext {
    public Object batchId;
    public Object[] state;

    public ProcessorContext(Object batchId, Object[] state) {
        this.batchId = batchId;
        this.state = state;
    }
}</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<h2>TridentCollector</h2>
<p>tridentcollector在emit的时候将消息由各个TupleReceiver进行处理。目前仅有BridgeReceiver实现了该接口。</p>
<p>BridgeReceiver负责将消息发送给另外的Bolt进行处理。这里说的“另外的Bolt”是指Vanilla Topology中的Bolt.</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 14:45:13</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/apache/" title="apache">apache</a>, <a href="https://www.iamivan.net/tag/storm/" title="storm">storm</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Apache Storm技术实战的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQo2Ap.html" rel="bookmark">Apache Spark技术实战（三）利用Spark将json文件导入Cassandra &amp;amp&semi;SparkR的安装及使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;一&gt;利用Spark将json文件导入Cassandra 概要 sbt cassandra spark-cassandra-connector 实验目的 将存在于json文件中的数据导入到cassandra数据库,目前由cassandra提供的官方工具是json2sstable,由于对cassandra本身了解不多,这个我还没有尝试成功. 但想到spark sql中可以读取json文件,而spark-cassadra-connector又提供了将RDD存入到数据库的功能,我想是否可以将两者结合			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmekWz.html" rel="bookmark">Apache Spark技术实战（二）KafkaWordCount &amp;amp&semi;PackratParsers实例 &amp;amp&semi;Spark Cassandra Connector的安装和使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;一&gt;KafkaWordCount 概要 Spark应用开发实践性非常强,很多时候可能都会将时间花费在环境的搭建和运行上,如果有一个比较好的指导将会大大的缩短应用开发流程.Spark Streaming中涉及到和许多第三方程序的整合,源码中的例子如何真正跑起来,文档不是很多也不详细. 本篇主要讲述如何运行KafkaWordCount,这个需要涉及Kafka集群的搭建,还是说的越仔细越好. 搭建Kafka集群 步骤1:下载kafka 0.8.1及解压 wget https://www.apach			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBQWrb.html" rel="bookmark">Apache Spark技术实战（四）spark-submit常见问题及其解决 &amp;amp&semi;CassandraRDD高并发数据读取实现剖析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;一&gt;spark-submit常见问题及其解决 概要 编写了独立运行的Spark Application之后,需要将其提交到Spark Cluster中运行,一般会采用spark-submit来进行应用的提交,在使用spark-submit的过程中,有哪些事情需要注意的呢? 本文试就此做一个小小的总结. spark-defaults.conf Spark-defaults.conf的作用范围要搞清楚,编辑driver所在机器上的spark-defaults.conf,该文件会影响 到drive			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9YlJVM.html" rel="bookmark">Apache Spark技术实战（一）Standalone部署模式下的临时文件清理&amp;amp&semi;日志级别修改</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;一&gt;Standalone部署模式下的临时文件清理 概要 在Standalone部署模式下,Spark运行过程中会创建哪些临时性目录及文件,这些临时目录和文件又是在什么时候被清理,本文将就这些问题做深入细致的解答. 从资源使用的方面来看,一个进程运行期间会利用到这四个方面的资源,分别是CPU,内存,磁盘和网络.进程退出之后,CPU,内存和网络都会由操作系统负责释放掉,但是运行过程中产生临时文件如果进程自己不在退出之前有效清除,就会留下一地鸡毛,浪费有效的存储空间. 部署时的第三方依赖 再提出具			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWXQomp.html" rel="bookmark">Docker集群轻松部署Apache Storm</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Apache Storm是一个非常常用的实时流计算框架.最近有客户来咨询如何在Docker中运行Apache Storm的问题.我之前读过一篇文章介绍Apache Storm在Docker环境的部署,The Joy Of Deploying Apache Storm On Docker Swarm.文章写的很好,但是整个过程需要从手工构建Docker集群环境开始,再一步步把Storm配置起来,虽然作者提到整个过程是&quot;a real joy&quot;,估计绝大多数用户依然会望而生畏. 利用Dock			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze7QL7M.html" rel="bookmark">Apache Storm 官方文档中文版</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接    译者:魏勇 About 本项目是 Apache Storm 官方文档的中文翻译版,致力于为有实时流计算项目需求和对 Apache Storm 感兴趣的同学提供有价值的中文资料,希望能够对大家的工作和学习有所帮助. 虽然 Storm 的正式推出已经有好几个年头了,发行版也已经到了 0.10.x,但是目前网络上靠谱的学习资料仍然不多,很多比较有价值的资料都过时了(甚至官方网站自己的资料都没有及时更新,这大概也是发展太快的社区的通病),而较新的资料大多比较零碎,在关键内容的描述上也有些			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgVkq1b.html" rel="bookmark">Apache Storm 衍生项目  &amp;amp&semi;  Apache Flink初接触</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				storm-yarn 概要 storm是一个近似于实时的计算框架,甩开hadoop上的原生mapreduce计算框架不只一条街.如果能将storm引入到hadoop中,对存储于hdfs的数据进行分析必然极大的提高处理性能.storm-yarn就是这样一个项目,由yahoo实现,目前已经开源. 除了storm-yarn试图将storm整合进hadoop,以提升hadoop的分析处理能力的尝试之外,Hortonworks也高调宣布在2014年推出整合了storm的hadoop发行版.当然Horton			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxY4BQp.html" rel="bookmark">Apache Storm源码阅读笔记&amp;amp&semi;OLAP在大数据时代的挑战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 &lt;一&gt;Apache Storm源码阅读笔记 楔子 自从建了Spark交流的QQ群之后,热情加入的同学不少,大家不仅对Spark很热衷对于Storm也是充满好奇.大家都提到一个问题就是有关storm内部实现机理的资料比较少,理解起来非常费劲. 尽管自己也陆续对storm的源码走读发表了一些博文,当时写的时候比较匆忙,有时候衔接的不是太好,此番做了一些整理,主要是针对TridentTopology部分,修改过的内容采用pdf格式发布,方便打印. 文章中有些内容的理解得益于徐明明和fxjwind两			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z78wxrb.html" rel="bookmark">《Storm分布式实时计算模式》&mdash;&mdash;2&period;2　Storm技术栈简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.2 Storm技术栈简介 在安装Storm之前,我们来看看Storm和topology是基于哪些技术建立的.2.2.1 Java和ClojureStorm运行在Java虚拟机上,大部分是使用Java和Clojure进行开发的.Storm的主要接口都是通过Java语言定制的,Storm使用Python实现了可执行程序.除了这些程序,由于Java使用了Apache Thrift接口,Java还友好的兼容多种其他语言.Storm的组件(spout和bot)实际上可以使用任何当前服务器安装支持的语言			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b281op.html" rel="bookmark" class="title">&period;Net Framework 4&period;0 功能介绍</a>
					<div>
						.Net Framework 4.0 功能介绍 微软发布了 Visual Studio 2010 和 .NET Framework 4.0 的Beta 2测试版,微软往Framework 4.0里又塞 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MY4OQb.html" rel="bookmark" class="title">FreeBSD连载&lpar;28&rpar;：Packages Collection</a>
					<div>
						FreeBSD中提供了上G字节大小的预编译并打好包的二进制应用软件包,这些软件包能够立即安装使用.在软件包中不但记录了二进制软件的内容,还包括这些软件的安装位置.软件包的描述信息,以及软件包之间的依赖 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYg1ez.html" rel="bookmark" class="title">网站运营的前期思考工作</a>
					<div>
						网站运营 以下的内容是在我经历了一段时间网站运营工作后的一点想法,希望对准备开发制作网站的朋友有一点提示. 网站项目不是在卖白菜,不是你今天做,明天就一定会卖出去.也许我们想做一个网站,而且想把她长久 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9r5op.html" rel="bookmark" class="title">PHP中读取某个目录下的文件</a>
					<div>
						&lt;?php /*  PHP Version:  28 April 2005  Author:  move2rent  purpose:读取某个目录下的文件 */  //要读取的目录 $folde ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PVrnM.html" rel="bookmark" class="title">C&plus;&plus; Builder在运行时创建BDE别名</a>
					<div>
						通过bde别名来连接数据库,确实很方便,然而,那些没有确定的数据库,我们却无法给它创建别名. 而大多数时候,当我们把程序交给别人真正投入使用时,别名的路径也是不确定的.这就要求我们在程序运行时动态连接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjPP3p.html" rel="bookmark" class="title">浅谈Excel报表在Java程序中的应用</a>
					<div>
						引言 报表输出是开发数据库应用程序经常涉及的内容,而一般的报表往往缺乏通用性,不方便用户进行个性化编辑.Excel是Windos平台上优秀的电子表格软件,如果把报表输出成Excel格式,用户就可以利用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrDgJp.html" rel="bookmark" class="title">XP系统虚拟内存设为&amp;quot&semi;0&amp;quot&semi;及其需要注意的事项</a>
					<div>
						  XP系统虚拟内存设为&quot;0&quot;及其需要注意的事项           而许多WinXP系统的用户电脑配置较低,只用来上网或者看看电影,不玩大型游戏也不安装其它软件,它们认为不需要使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLv1ab.html" rel="bookmark" class="title">PowerPoint中文字动画效果，让PPT幻灯片更有冲击力</a>
					<div>
						PowerPoint提供了许多现成的动画效果,但是有时在显示一些标题类的需要强调的文本或图片时,PowerPoint本身提供的效果还不够丰富和震撼,下面教大家将PowerPoint提供的效果组合应用, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wQA1p.html" rel="bookmark" class="title">PowerPoint2010中参考线的使用技巧</a>
					<div>
						  在PPT中,参考线能够有效的帮助我们快速地去对齐各个对象,方便快捷.案例阐述了如何调出.使用.复制和删除参考线.下面,大家就跟本小编一起学习参考线的具体使用吧. ①启动PowerPoint2010 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZXq8z.html" rel="bookmark" class="title">andengine-用户点击屏幕时实现sprite更换图片</a>
					<div>
						问题描述 用户点击屏幕时实现sprite更换图片 我使用AndEngine 来实现sprite更换图片.使用这个sprite可以在屏幕之间来回拖动图片. 所以我想实现的是当用户触摸屏幕的任何一个地方, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1l20jb.html" rel="bookmark" class="title">云栖大会惊现体感互娱 视频云能力全面释放</a>
					<div>
						2017云栖大会已经拉开帷幕,全球4万多名IT从业人员相继奔赴杭州云栖小镇,来共同见证这场全球TOP级云计算盛会.本次大会的主题为飞天智能,通过3场主论坛.22场前沿峰会.100+分论坛,400+科技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOl4qmb.html" rel="bookmark" class="title">Kafka - SQL 引擎分享</a>
					<div>
						1.概述 大多数情况下,我们使用 Kafka 只是作为消息处理.在有些情况下,我们需要多次读取 Kafka 集群中的数据.当然,我们可以通过调用 Kafka 的 API 来完成,但是针对不同的业务需求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6B6PM.html" rel="bookmark" class="title">能否只修改IEnumerable&amp;amp&semi;amp&semi;lt&semi;T&amp;amp&semi;amp&semi;gt&semi;不提交？</a>
					<div>
						问题描述 实际需求是这样的:客户端点击某个按钮之后,改变了数据状态,并保存到数据库中,而IEnumerable&lt;T&gt;并没有改变,如果要改变IEnumerable&lt;T&gt;,有两种方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Ag9Bz.html" rel="bookmark" class="title">快讯：苹果iOS6将强制执行严格隐私保护</a>
					<div>
						本文讲的是 : 快讯:苹果iOS6将强制执行严格隐私保护   , [IT168 评论]6月21日消息,据Mac OS新闻网站Mac Rumors网站报道,苹果公司在iOS的发行说明中,对iOS 6上运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAE3Vp.html" rel="bookmark" class="title">沪江、外研社、新东方联合组建海外出版公司，AI 背景下的出版业将去何处？</a>
					<div>
						AI 这场火,还是烧到了出版业. 近日,沪江.外研社.新东方正式达成战略合作协议,三方将在英国组建合资出版公司 Innova Press Limited,聚焦海外教育版权领域,当然这只是开始的第一步. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLnY6p.html" rel="bookmark" class="title">自己编一控件，要求标题栏在最上面，并有上下左右滚动条，能做到吗？</a>
					<div>
						问题描述 自己编一控件,像DataGridView一样,上下滚动时,标题栏固定,下面的详细数据可以上下滚动条滚动显示.左右滚动时,标题栏和数据一起随滚动条滚动.本人是c#的新手,刚好项目又有这样的要求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWBk8z.html" rel="bookmark" class="title">智能硬件的冷思考（下）</a>
					<div>
						  在上篇里提到的三个问题是智能硬件创业公司和大公司都无法回避的问题.归结起来,就是这么几个字:门槛高.投入大.回报周期长. 从这一年多,各创业公司反复试错的情况来看,智能硬件厂商还有无法回避的一个核 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7kvZM.html" rel="bookmark" class="title">weblogic上扩展插件该从哪里入手</a>
					<div>
						问题描述 weblogic上扩展插件该从哪里入手 有谁清楚吗?这两天看的头大了不摘到该从哪下手,网上资料也比较少 解决方案 参考:http://blog.csdn.net/zhengqiqiqinqi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvEO4M.html" rel="bookmark" class="title">宿迁打造酒业巨头 洋河股份欲揽双沟四成股权</a>
					<div>
						去年下半年从维维股份置出的双沟酒业四成股权,或将落户0.5.html&quot;&gt;洋河股份.洋河.双沟两家同在宿迁的酒业公司,将通过此次整合打造酒业集团,做大做强白酒产业. 因拟披露http:/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Z67Zb.html" rel="bookmark" class="title">js利用事件的阻止冒泡实现点击空白模态框的隐藏&lowbar;javascript技巧</a>
					<div>
						很多时候,我们做前端的时候都会有这样的小功能,点击弹出某个框框,但是,有时候不想操作,就想点击某个空白处,隐藏该框框.假设如下场景,一个小按钮,点击可以弹出一个模态框. 就这么简单,但是我们想要点击空 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWmw3z.html" rel="bookmark" class="title">介绍Python中的一些高级编程技巧&lowbar;python</a>
					<div>
						 正文: 本文展示一些高级的Python设计结构和它们的使用方法.在日常工作中,你可以根据需要选择合适的数据结构,例如对快速查找性的要求.对数据一致性的要求或是对索引的要求等,同时也可以将各种数据结构 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWZAZz.html" rel="bookmark" class="title">ASP&period;NET 清除模式窗口数据缓存的操作方式&lowbar;实用技巧</a>
					<div>
						使用模式窗口showModalDialog()弹出页面在asp.net中经常用到 用的最多的就是点击&quot;修改&quot;按钮,弹出修改页面:修改成功之后,关闭修改页面,刷新父页面. 目前存在的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkma3z.html" rel="bookmark" class="title">JavaScript高级程序设计 读书笔记之十一 内置对象Global&lowbar;javascript技巧</a>
					<div>
						内置对象 定义:由ECMAScript实现提供的.独立于宿主环境的所有对象,在ECMAScript程序开始执行时出现. 由定义可知开发者不必明确实例化内置对象,它已被实例化了.在ECMAScript- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0E4Vp.html" rel="bookmark" class="title">在eclipse中运行正常，生成可运行jar包，双击运行不正常  用java -jar运行正常</a>
					<div>
						问题描述 rt,谢谢啊!在eclipse中运行正常,生成可运行jar包,双击运行不正常用java-jar运行正常 解决方案 解决方案二:步骤一:打开注册表,开始-&gt;运行(或者用快捷键WIN+R) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QP96p.html" rel="bookmark" class="title">java开发与架构QQ群16652424</a>
					<div>
						问题描述 java开发与架构QQ群16652424交流java开发与架构的心得! 解决方案 解决方案二:过来帮顶解决方案三:先前进了一个java群,进入喊话,都没人理.后来干脆退出了解决方案四:加了. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenRmAb.html" rel="bookmark" class="title">网站成败：&percnt;80在于网站定位</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 说到定位,很多朋友不以为然.有的朋 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyWmkM.html" rel="bookmark" class="title">万家企业倒闭小企业能否得救？</a>
					<div>
						前三季度广东关闭企业7148家 广东省中小企业局局长刘焕泉昨天接受记者采访时高调回应了&quot;广东企业倒闭5万多家陷入倒闭潮&quot;的不实传言,他披露,根据全省各地中小企业行政主管部门上报的企 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wn9Zz.html" rel="bookmark" class="title">不允许错过的Linux常用命令集合&lowbar;Linux</a>
					<div>
						直接贴上学习笔记: 系统信息 arch 显示机器的处理器架构(1) uname -m 显示机器的处理器架构(2) uname -r 显示正在使用的内核版本 dmidecode -q 显示硬件系统部件  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAZ98p.html" rel="bookmark" class="title">百度微博近日上线 将取消身份证实名认证</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 飞象网讯(吉利/文)此前,飞象网曾报道百度说吧将变身为微博.近日,飞象网又了解到,变身后的百度微博将于4月15日左右上线,同时将取消此前需要填入身份证号 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmROJaz.html" rel="bookmark" class="title">百度测试博客搜索 不支持搜狐&excl;</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 百度测试博客搜索(http://b ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
